<template>
  <Container
    class="border-b-4 border-gray-300"
    :class="{ '!bg-stone-50 border-none': isArchived(data) }"
    :style="{ 'border-color': !isArchived(data) && data.color }"
  >
    <section class="flex items-center text-lg font-light max-w-full">
      <section class="flex flex-auto items-center truncate">
        <span class="inline-flex justify-center items-center shrink-0 w-8 h-8 bg-gradient-to-l from-teal-400 to-cyan-500 text-white rounded-lg">
          <v-icon
            icon="mdi-home"
            size="small"
          />
        </span>

        <span
          v-tooltip:top-start="{ text: data.name, openOnClick: true }"
          class="ml-2 max-w-full truncate"
        >
          {{ data.name }}
        </span>
      </section>

      <menu class="flex items-center ml-4">
        <EditPropertyForm
          v-if="!isArchived(data)"
          :data="data"
        />

        <ArchivePropertyForm :data="data" />
      </menu>
    </section>

    <v-divider class="border-gray-800 my-4" />

    <section class="text-gray-500">
      <v-chip
        v-if="isArchived(data)"
        prepend-icon="mdi-archive-outline"
        class="text-amber-600 mr-2"
      >
        В архиве
      </v-chip>

      <v-chip prepend-icon="mdi-calendar-outline">
        {{ dt.display(data.createdAt) }}
      </v-chip>
    </section>

    <section class="flex items-end mt-4">
      <span class="text-gray-500 text-center w-8 shrink-0">
        <v-icon
          icon="mdi-bed-outline"
          size="small"
        />
      </span>

      <span class="text-2xl tracking-wider font-bold leading-none">
        {{ data.capacity }}
      </span>

      <span class="leading-none text-gray-500 ml-1 pb-[1.5px]">
        {{ capacityLabel }}
      </span>
    </section>
  </Container>
</template>

<script setup lang="ts">
import { computed } from 'vue';

import { useDateTime } from '@/composables';
import { isArchived, getCapacityLabel } from '@/utils';

import EditPropertyForm from './EditPropertyForm.vue';
import ArchivePropertyForm from './ArchivePropertyForm.vue';

import Container from '@/components/layout/Container.vue';

const props = defineProps<{ data: IProperty }>();
const dt = useDateTime();

const capacityLabel = computed(() => {
  return getCapacityLabel(props.data.capacity);
});
</script>